--[[
	9 P228 Functions for Admins
		- Bugfree version
	Version: 1.1

	Original script by Snake_Eater
]]--


new = {}

for i=1, 32 do
	new[i]=0
end

players={}

for i=1, 32 do
	players[i]=0
end

admins={16202,25021}

dedicated=true

if dedicated then
	addhook ("say","say_hook")
else
	addhook ("parse","parse_hook")
end

function say_hook(id, cmd)
	if isPlayerAdmin(id) then
		return updateHudText(id, cmd)
	end
end

function parse_hook(cmd)
	if (updateHudText(1, cmd)==1) then
		return 2
	end
end

function updateHudText(id, cmd)
	if cmd=="toggle_p228_adm_mode" and new[id]==0 then
		new[id] = 1
		parse ("sv_sound2 "..id.." weapons/click.wav")
		parse ("mp_wpndmg p228 1000000")
		parse ('hudtxt2 '..id..' 1 "000255000P228=normal" 30 10 0')
		return 1
	elseif cmd=="toggle_p228_adm_mode" and new[id]==1 then
		new[id] = 2
		parse ("sv_sound2 "..id.." weapons/click.wav")
		parse ("mp_wpndmg p228 0")
		parse ('hudtxt2 '..id..' 1 "255000000P228=normal" 20 10 0')
		parse ('hudtxt2 '..id..' 2 "000255000P228=kick" 30 20 0')
		return 1
	elseif cmd=="toggle_p228_adm_mode" and new[id]==2 then
		new[id] = 3
		parse ("sv_sound2 "..id.." weapons/click.wav")
		parse ("mp_wpndmg p228 0")
		parse ('hudtxt2 '..id..' 2 "255000000P228=kick" 20 20 0')
		parse ('hudtxt2 '..id..' 3 "000255000P228=ban" 30 30 0')
		return 1
	elseif cmd=="toggle_p228_adm_mode" and new[id]==3 then
		new[id] = 4
		parse ("sv_sound2 "..id.." weapons/click.wav")
		parse ("mp_wpndmg p228 0")
		parse ('hudtxt2 '..id..' 3 "255000000P228=ban" 20 30 0')
		parse ('hudtxt2 '..id..' 4 "000255000P228=catch" 30 40 0')
		return 1
	elseif cmd=="toggle_p228_adm_mode" and new[id]==4 then
		new[id] = 5
		parse ("sv_sound2 "..id.." weapons/click.wav")
		parse ("mp_wpndmg p228 0")
		parse ('hudtxt2 '..id..' 4 "255000000P228=catch" 20 40 0')
		parse ('hudtxt2 '..id..' 5 "000255000P228=data" 30 50 0')
		return 1
	elseif cmd=="toggle_p228_adm_mode" and new[id]==5 then
		new[id] = 6
		parse ("sv_sound2 "..id.." weapons/click.wav")
		parse ("mp_wpndmg p228 0")
		parse ('hudtxt2 '..id..' 5 "255000000P228=data" 20 50 0')
		parse ('hudtxt2 '..id..' 6 "000255000P228=freeze" 30 60 0')
		return 1
	elseif cmd=="toggle_p228_adm_mode" and new[id]==6 then 
		new[id] = 7
		parse ("sv_sound2 "..id.." weapons/click.wav")
		parse ("mp_wpndmg p228 0")
		parse ('hudtxt2 '..id..' 6 "255000000P228=freeze" 20 60 0')
		parse ('hudtxt2 '..id..' 7 "000255000P228=come back" 30 70 0')
		return 1
	elseif cmd=="toggle_p228_adm_mode" and new[id]==7 then 
		new[id] = 8
		parse ("sv_sound2 "..id.." weapons/click.wav")
		parse ("mp_wpndmg p228 0")
		parse ('hudtxt2 '..id..' 7 "255000000P228=come back" 20 70 0')
		parse ('hudtxt2 '..id..' 8 "000255000P228=unfreeze" 30 80 0')
		return 1
	elseif cmd=="toggle_p228_adm_mode" and new[id]==8 then 
		new[id] = 9
		parse ("sv_sound2 "..id.." weapons/click.wav")
		parse ("mp_wpndmg p228 0")
		parse ('hudtxt2 '..id..' 8 "255000000P228=unfreeze" 20 80 0')
		parse ('hudtxt2 '..id..' 9 "000255000P228=strip" 30 90 0') 
		return 1
	elseif cmd=="toggle_p228_adm_mode" and new[id]==9 then 
		new[id] = 1
		parse ("sv_sound2 "..id.." weapons/click.wav")
		parse ("mp_wpndmg p228 1000000")
		parse ('hudtxt2 '..id..' 1 "000255000P228=normal" 30 10 0')
		parse ('hudtxt2 '..id..' 9 "255000000P228=strip" 20 90 0')
		return 1
	end
end

addhook ("hit","hit_hook")
function hit_hook(id,source,we)
	if (((not dedicated) and source==1) or (dedicated and isPlayerAdmin(source))) then
		if we==4 and player(id,"health") > 0 and new[source]==1 then
			parse ("killplayer "..id.."")
		elseif we==4 and new[source]==2 then
			parse ("kick "..id.."")
		elseif we==4 and new[source]==3 then
			parse ("banip "..player(id,"ip").."")
		elseif new[source]==4 and we==4 then
			local x=player(id,"tilex")
			local y=player(id,"tiley")
			if tile(x-1, y-1, "walkable") then parse ("spawnobject 5 "..(x-1).." "..(y-1)) end
			if tile(x, y-1, "walkable") then parse ("spawnobject 5 "..(x).." "..(y-1)) end
			if tile(x+1, y-1, "walkable") then parse ("spawnobject 5 "..(x+1).." "..(y-1)) end
			if tile(x-1, y, "walkable") then parse ("spawnobject 5 "..(x-1).." "..(y)) end
			if tile(x+1, y, "walkable") then parse ("spawnobject 5 "..(x+1).." "..(y)) end
			if tile(x-1, y+1, "walkable") then parse ("spawnobject 5 "..(x-1).." "..(y+1)) end
			if tile(x, y+1, "walkable") then parse ("spawnobject 5 "..(x).." "..(y+1)) end
			if tile(x+1, y+1, "walkable") then parse ("spawnobject 5 "..(x+1).." "..(y+1)) end
		elseif we==4 and new[source]==5 then
			msg2(1,"255255000Name= "..player(id,"name").."          Health= "..player(id,"health"))
			msg2(1,"255255000Id= "..id.."                 Ip= "..player(id,"ip"))
			msg2(1,"255255000Score= "..player(id,"score").."          Deaths= "..player(id,"deaths"))
			msg2(1,"255255000Team= "..player(id,"team"))
		elseif we==4 and new[source]==7 then
			parse ("setpos "..id.." "..player(source,"x").." "..player(source,"y"))
		elseif we==4 and new[source]==6 then
			parse ("speedmod "..id.." -100")
			players[id]=true
		elseif we==4 and new[source]==8 then
			parse ("speedmod "..id.." 0")
			players[id]=false
		elseif we==4 and new[source]==9 then
			for z=1,88,1 do
				parse ("strip "..id.." "..z.."")
			end
		end
	end
end

addhook ("spawn","lop")
function lop(id)
	if (((not dedicated) and id==1) or (dedicated and isPlayerAdmin(id))) then
		if new[id]==1 then
			parse ('hudtxt2 '..id..' 1 "000255000P228=normal" 30 10 0')
		else
			parse ('hudtxt2 '..id..' 1 "255000000P228=normal" 20 10 0')
		end
		if new[id]==2 then
			parse ('hudtxt2 '..id..' 2 "000255000P228=kick" 30 20 0')
		else
			parse ('hudtxt2 '..id..' 2 "255000000P228=kick" 20 20 0')
		end
		if new[id]==3 then
			parse ('hudtxt2 '..id..' 3 "000255000P228=ban" 30 30 0')
		else
			parse ('hudtxt2 '..id..' 3 "255000000P228=ban" 20 30 0')
		end
		if new[id]==4 then
			parse ('hudtxt2 '..id..' 4 "000255000P228=catch" 30 40 0')
		else
			parse ('hudtxt2 '..id..' 4 "255000000P228=catch" 20 40 0')
		end
		if new[id]==5 then
			parse ('hudtxt2 '..id..' 5 "000255000P228=data" 30 50 0')
		else
			parse ('hudtxt2 '..id..' 5 "255000000P228=data" 20 50 0')
		end
		if new[id]==6 then
			parse ('hudtxt2 '..id..' 6 "000255000P228=freeze" 30 60 0')
		else
			parse ('hudtxt2 '..id..' 6 "255000000P228=freeze" 20 60 0')
		end
		if new[id]==7 then
			parse ('hudtxt2 '..id..' 7 "000255000P228=come back" 30 70 0')
		else
			parse ('hudtxt2 '..id..' 7 "255000000P228=come back" 20 70 0')
		end
		if new[id]==8 then
			parse ('hudtxt2 '..id..' 8 "000255000P228=unfreeze" 30 80 0')
		else
			parse ('hudtxt2 '..id..' 8 "255000000P228=unfreeze" 20 80 0')
		end
		if new[id]==9 then
			parse ('hudtxt2 '..id..' 9 "000255000P228=strip" 30 90 0')
		else
			parse ('hudtxt2 '..id..' 9 "255000000P228=strip" 20 90 0')
		end
		parse ('hudtxt2 '..id..' 34 "2552550001." 0 10 0')
		parse ('hudtxt2 '..id..' 35 "2552550002." 0 20 0')
		parse ('hudtxt2 '..id..' 36 "2552550003." 0 30 0')
		parse ('hudtxt2 '..id..' 37 "2552550004." 0 40 0')
		parse ('hudtxt2 '..id..' 38 "2552550005." 0 50 0')
		parse ('hudtxt2 '..id..' 39 "2552550006." 0 60 0')
		parse ('hudtxt2 '..id..' 40 "2552550007." 0 70 0')
		parse ('hudtxt2 '..id..' 41 "2552550008." 0 80 0')
		parse ('hudtxt2 '..id..' 42 "2552550009." 0 90 0')
		
		if (not dedicated) then parse ("bind mouse3 toggle_p228_adm_mode") end
		parse ("equip "..id.." 4")
	end
end

addhook("join","joinhook")
function joinhook(id)
	new[id] = 0
end

-------------------
-- Little helper --
-------------------

function isPlayerAdmin(id)
	for _, usgn in ipairs(admins) do
		if player(id,"usgn") == usgn then
			return true
		end
	end
	return false
end